SoPolygonOffset Class Reference
Node Classes

The SoPolygonOffset class is a node type for "layering" rendering primitives. More...

`#include <Inventor/nodes/SoPolygonOffset.h>`

Inheritance diagram for SoPolygonOffset:

## Public Types

enum | Style { FILLED = SoPolygonOffsetElement::FILLED , LINES = SoPolygonOffsetElement::LINES , POINTS = SoPolygonOffsetElement::POINTS }
Public Types inherited from SoNode

enum

NodeType {
INVENTOR = 0x0000 , VRML1 = 0x0001 , VRML2 = 0x0002 , INVENTOR_1 = 0x0004 ,
INVENTOR_2_0 = 0x0008 , INVENTOR_2_1 = 0x0010 , INVENTOR_2_5 = 0x0020 , INVENTOR_2_6 = 0x0040 ,
COIN_1_0 = 0x0080 , COIN_2_0 = 0x0100 , EXTENSION = 0x0200 , COIN_2_2 = 0x0400 ,
COIN_2_3 = 0x0800 , COIN_2_4 = 0x1000 , INVENTOR_5_0 = 0x2000 , COIN_2_5 = 0x4000 ,
COIN_3_0 = 0x8000 , INVENTOR_6_0 = 0x10000 , COIN_4_0 = 0x20000
}

## Public Member Functions

virtual SoType | getTypeId (void) const
| SoPolygonOffset (void)
virtual void | doAction (SoAction *action)
virtual void | callback (SoCallbackAction *action)
virtual void | GLRender (SoGLRenderAction *action)
Public Member Functions inherited from SoNode
void | setOverride (const SbBool state)
SbBool | isOverride (void) const
void | setNodeType (const NodeType type)
NodeType | getNodeType (void) const
virtual SoNode * | copy (SbBool copyconnections=FALSE) const
virtual SbBool | affectsState (void) const
virtual void | GLRenderBelowPath (SoGLRenderAction *action)
virtual void | GLRenderInPath (SoGLRenderAction *action)
virtual void | GLRenderOffPath (SoGLRenderAction *action)
virtual void | getBoundingBox (SoGetBoundingBoxAction *action)
virtual void | getMatrix (SoGetMatrixAction *action)
virtual void | handleEvent (SoHandleEventAction *action)
virtual void | pick (SoPickAction *action)
virtual void | rayPick (SoRayPickAction *action)
virtual void | search (SoSearchAction *action)
virtual void | write (SoWriteAction *action)
virtual void | audioRender (SoAudioRenderAction *action)
virtual void | getPrimitiveCount (SoGetPrimitiveCountAction *action)
virtual void | grabEventsSetup (void)
virtual void | grabEventsCleanup (void)
virtual void | startNotify (void)
virtual void | notify (SoNotList *l)
SbUniqueId | getNodeId (void) const
virtual SoChildList * | getChildren (void) const
virtual void | writeInstance (SoOutput *out)
virtual SoNode * | addToCopyDict (void) const
virtual void | copyContents (const SoFieldContainer *from, SbBool copyconnections)
virtual SoFieldContainer * | copyThroughConnection (void) const
Public Member Functions inherited from SoFieldContainer
void | setToDefaults (void)
SbBool | hasDefaultValues (void) const
SbBool | fieldsAreEqual (const SoFieldContainer *container) const
void | copyFieldValues (const SoFieldContainer *container, SbBool copyconnections=FALSE)
SbBool | set (const char *const fielddata)
void | get (SbString &fielddata)
virtual int | getFields (SoFieldList &l) const
virtual int | getAllFields (SoFieldList &l) const
virtual SoField * | getField (const SbName &name) const
virtual SoField * | getEventIn (const SbName &name) const
virtual SoField * | getEventOut (const SbName &name) const
SbBool | getFieldName (const SoField *const field, SbName &name) const
SbBool | enableNotify (const SbBool flag)
SbBool | isNotifyEnabled (void) const
SbBool | set (const char *fielddata, SoInput *input)
void | get (SbString &fielddata, SoOutput *out)
virtual SbBool | validateNewFieldValue (SoField *field, void *newval)
virtual void | addWriteReference (SoOutput *out, SbBool isfromfield=FALSE)
SbBool | getIsBuiltIn (void) const
virtual void | getFieldsMemorySize (size_t &managed, size_t &unmanaged) const
void | setUserData (void *userdata) const
void * | getUserData (void) const
Public Member Functions inherited from SoBase
void | ref (void) const
void | unref (void) const
void | unrefNoDelete (void) const
int32_t | getRefCount (void) const
void | touch (void)
SbBool | isOfType (SoType type) const
| Returns `TRUE` if the type of this object is either of the same type or inherited from type.
virtual SbName | getName (void) const
virtual void | setName (const SbName &newname)
void | addAuditor (void *const auditor, const SoNotRec::Type type)
void | removeAuditor (void *const auditor, const SoNotRec::Type type)
const SoAuditorList & | getAuditors (void) const
SbBool | shouldWrite (void)
void | assertAlive (void) const

## Static Public Member Functions

static SoType | getClassTypeId (void)
static void | initClass (void)
| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.
Static Public Member Functions inherited from SoNode
static uint32_t | getCompatibilityTypes (const SoType &nodetype)
static SoType | getClassTypeId (void)
static SoNode * | getByName (const SbName &name)
static int | getByName (const SbName &name, SoNodeList &l)
static void | initClass (void)
| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.
static void | initClasses (void)
static SbUniqueId | getNextNodeId (void)
static int | getActionMethodIndex (const SoType type)
static void | getBoundingBoxS (SoAction *action, SoNode *node)
static void | GLRenderS (SoAction *action, SoNode *node)
static void | callbackS (SoAction *action, SoNode *node)
static void | getMatrixS (SoAction *action, SoNode *node)
static void | handleEventS (SoAction *action, SoNode *node)
static void | pickS (SoAction *action, SoNode *node)
static void | rayPickS (SoAction *action, SoNode *node)
static void | searchS (SoAction *action, SoNode *node)
static void | writeS (SoAction *action, SoNode *node)
static void | audioRenderS (SoAction *action, SoNode *node)
static void | getPrimitiveCountS (SoAction *action, SoNode *node)
Static Public Member Functions inherited from SoFieldContainer
static void | initClass (void)
| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.
static SoType | getClassTypeId (void)
| This static method returns the SoType object associated with objects of this class.
static void | cleanupClass (void)
static void | initCopyDict (void)
static void | addCopy (const SoFieldContainer *orig, const SoFieldContainer *copy)
static SoFieldContainer * | checkCopy (const SoFieldContainer *orig)
static SoFieldContainer * | findCopy (const SoFieldContainer *orig, const SbBool copyconnections)
static void | copyDone (void)
Static Public Member Functions inherited from SoBase
static void | initClass (void)
| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.
static SoType | getClassTypeId (void)
| This static method returns the SoType object associated with objects of this class.
static void | addName (SoBase *const base, const char *const name)
static void | removeName (SoBase *const base, const char *const name)
static void | incrementCurrentWriteCounter (void)
static void | decrementCurrentWriteCounter (void)
static SoBase * | getNamedBase (const SbName &name, SoType type)
static int | getNamedBases (const SbName &name, SoBaseList &baselist, SoType type)
static SbBool | read (SoInput *input, SoBase *&base, SoType expectedtype)
static void | setInstancePrefix (const SbString &c)
static void | setTraceRefs (SbBool trace)
static SbBool | getTraceRefs (void)
static SbBool | connectRoute (SoInput *input, const SbName &fromnodename, const SbName &fromfieldname, const SbName &tonodename, const SbName &tofieldname)
static SbBool | readRoute (SoInput *input)

## Public Attributes

SoSFFloat | factor
SoSFFloat | units
SoSFBitMask | styles
SoSFBool | on

## Protected Member Functions

virtual const SoFieldData * | getFieldData (void) const
virtual | ~SoPolygonOffset ()
Protected Member Functions inherited from SoNode
| SoNode (void)
virtual | ~SoNode ()
virtual SbBool | readInstance (SoInput *in, unsigned short flags)
Protected Member Functions inherited from SoFieldContainer
| SoFieldContainer (void)
virtual | ~SoFieldContainer ()
Protected Member Functions inherited from SoBase
| SoBase (void)
virtual | ~SoBase ()
virtual void | destroy (void)
SbBool | hasMultipleWriteRefs (void) const
SbBool | writeHeader (SoOutput *out, SbBool isgroup, SbBool isengine) const
void | writeFooter (SoOutput *out) const
virtual const char * | getFileFormatName (void) const
virtual SoNotRec | createNotRec (void)

## Static Protected Member Functions

static const SoFieldData ** | getFieldDataPtr (void)
Static Protected Member Functions inherited from SoNode
static const SoFieldData ** | getFieldDataPtr (void)
static void | setNextActionMethodIndex (int index)
static int | getNextActionMethodIndex (void)
static void | incNextActionMethodIndex (void)
static void | setCompatibilityTypes (const SoType &nodetype, const uint32_t bitmask)
Static Protected Member Functions inherited from SoBase
static uint32_t | getCurrentWriteCounter (void)
static void | staticDataLock (void)
static void | staticDataUnlock (void)

## Additional Inherited Members

Protected Types inherited from SoBase
enum | BaseFlags { IS_ENGINE = 0x01 , IS_GROUP = 0x02 }
Protected Attributes inherited from SoNode
SbUniqueId | uniqueId
Protected Attributes inherited from SoFieldContainer
SbBool | isBuiltIn
Static Protected Attributes inherited from SoNode
static SbUniqueId | nextUniqueId = 1
static int | nextActionMethodIndex = 0

## Detailed Description

The SoPolygonOffset class is a node type for "layering" rendering primitives.

A common problem with real time 3D rendering systems is that rendered primitives which are at approximately the same depth with regard to the camera viewpoint will appear to flicker. I.e.: from one angle one primitive will appear to be closer, while at another angle, another primitive will appear closer. When this happens, the rendered graphics at that part of the scene will of course look a lot less visually pleasing.

One common situation where this problem often occurs is when you attempt to put a wireframe grid as an outline on top of filled polygons.

The cause of the problem described above is that the z-buffer of any render system has a limited resolution, often at 16, 24 or 32 bits. Because of this, primitives which are close will sometimes get the same depth value in the z-buffer, even though they are not actually at the same depth-coordinate.

To rectify the flickering problem, this node can be inserted in the scene graph at the proper place(s) to explicitly define how polygons, lines and/or points should be offset with regard to other primitives.

As for the details of how the SoPolygonOffset::factor and SoPolygonOffset::units should be set, we quote the OpenGL documentation:

        The value of the offset is

            factor * DZ + r * units

        where DZ is a measurement of the change in depth relative to the
        screen area of the polygon, and r is the smallest value that is
        guaranteed to produce a resolvable offset for a given
        implementation. The offset is added before the depth test is
        performed and before the value is written into the depth buffer.

One word of notice with regard to the above quote from the OpenGL documentation: it doesn't really make sense to set "factor" and "units" to values with different signs, i.e. "factor" to a negative value and "units" to a positive value, or vice versa.

The pixels would then be "pushed back" in Z-order by one part of the equation, but at the same time be "pushed forward" by the other part of the equation. This would most likely give very inconsistent results, but which may at first look OK.

We mention this potential for making a mistake, as it seems to be a quite common error.

Below is a simple, correct usage example:

    #Inventor V2.1 ascii

    Separator {
       Coordinate3 { point [ -1 -1 0, 1 -1 0, 1 1 0, -1 1 0 ] }

       Separator {
          BaseColor { rgb 1 1 0 }
          # needs to draw polygons-as-line, and not "real" lines -- see
          # documentation below on why this is so:
          DrawStyle { style LINES }
          # draw two triangles, to get a line crossing the face of the
          # polygon:
          IndexedFaceSet { coordIndex [ 0, 1, 2, -1, 0, 2, 3 -1 ] }
       }

       PolygonOffset {
          styles FILLED
          factor 1.0
          units 1.0
       }

       BaseColor { rgb 0 0.5 0 }
       FaceSet { numVertices [ 4 ] }
    }

Without the polygon offset node in the above example, the lines may look irregularly stippled with some graphics card drivers, as parts of it will show through the faceset, others not. This happens on seemingly random parts, as the z-buffer floating point calculations will be fickle with regard to whether or not the polygon or the line will be closer to the camera.

See the API documentation of the SoPolygonOffset::styles field below for a discussion of one important limitation of OpenGL's z-buffer offset mechanism: it only works with polygons or polygons rendered in line or point mode, using the SoDrawStyle::style field.

FILE FORMAT/DEFAULTS:

PolygonOffset {
factor 1
units 1
styles FILLED
on TRUE
}
SoPolygonOffset::styles
SoSFBitMask styles
Definition SoPolygonOffset.h:59
SoPolygonOffset::on
SoSFBool on
Definition SoPolygonOffset.h:60
SoPolygonOffset::FILLED
@ FILLED
Definition SoPolygonOffset.h:52
SoPolygonOffset::factor
SoSFFloat factor
Definition SoPolygonOffset.h:57
SoPolygonOffset::units
SoSFFloat units
Definition SoPolygonOffset.h:58

Since
  TGS Inventor 2.5
  Coin 1.0

## Member Enumeration Documentation

## Style

enum SoPolygonOffset::Style

Enumeration of the rendering primitives which can be influenced by an SoPolygonOffset node.

Enumerator
FILLED | The polygon face should be offset.
LINES | The polygon edges should be offset.
POINTS | The polygon vertices should be offset.

## Constructor & Destructor Documentation

## SoPolygonOffset()

SoPolygonOffset::SoPolygonOffset | ( | void |  | ) |

Constructor.

## ~SoPolygonOffset()

SoPolygonOffset::~SoPolygonOffset | ( |  | ) |

protected virtual

Destructor.

## Member Function Documentation

## getClassTypeId()

SoType SoPolygonOffset::getClassTypeId | ( | void |  | ) |

static

This static method returns the SoType object associated with objects of this class.

## getTypeId()

SoType SoPolygonOffset::getTypeId | ( | void |  | ) | const

virtual

Returns the type identification of an object derived from a class inheriting SoBase. This is used for runtime type checking and "downward" casting.

Implements SoBase.

## getFieldDataPtr()

const SoFieldData ** SoPolygonOffset::getFieldDataPtr | ( | void |  | ) |

static protected

This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.
Returns the SoFieldData class which holds information about fields in this node.

## getFieldData()

const SoFieldData * SoPolygonOffset::getFieldData | ( | void |  | ) | const

protected virtual

Returns a pointer to the class-wide field data storage object for this instance. If no fields are present, returns `NULL`.

Reimplemented from SoFieldContainer.

## doAction()

void SoPolygonOffset::doAction | ( | SoAction * | action | ) |

virtual

This function performs the typical operation of a node for any action.

Reimplemented from SoNode.

## callback()

void SoPolygonOffset::callback | ( | SoCallbackAction * | action | ) |

virtual

Action method for SoCallbackAction.

Simply updates the state according to how the node behaves for the render action, so the application programmer can use the SoCallbackAction for extracting information about the scene graph.

Reimplemented from SoNode.

## GLRender()

void SoPolygonOffset::GLRender | ( | SoGLRenderAction * | action | ) |

virtual

Action method for the SoGLRenderAction.

This is called during rendering traversals. Nodes influencing the rendering state in any way or want to throw geometry primitives at OpenGL override this method.

Reimplemented from SoNode.

## Member Data Documentation

## factor

SoSFFloat SoPolygonOffset::factor

Offset multiplication factor. Scales the variable depth in the z-buffer of the rendered primitives.

See SoPolygonOffset's main class documentation above for detailed information on how the factor value is used.

Default value is 1.0.

## units

SoSFFloat SoPolygonOffset::units

Offset translation multiplication factor. Will be multiplied with the value which represents the smallest discrete step that can be distinguished with the underlying z-buffer resolution.

See SoPolygonOffset's main class documentation above for detailed information on how the units value is used.

Note that positive values will push geometry "away" into the z-buffer, while negative values will "move" geometry closer.

Default value is 1.0.

## styles

SoSFBitMask SoPolygonOffset::styles

The rendering primitive type to be influenced by this node. This is a bitmask variable, so you can select several primitive types (out of filled polygons, lines and points) be influenced by the offset at the same time.

There is one very important OpenGL limitation to know about in this regard: z-buffer offsetting can only be done for either polygons, or for polygons rendered as lines or as points.

So attempts at using this node to offset e.g. SoLineSet / SoIndexedLineSet or SoPointSet primitives will not work.

See the comments in the scene graph below for a detailed example on what SoPolygonOffset can and cannot do:

#Inventor V2.1 ascii
Separator {
# render polygon:
Coordinate3 { point [ -1.1 -1.1 0, 1.1 -1.1 0, 1.1 1.1 0, -1.1 1.1 0 ] }
BaseColor { rgb 0 0.5 0 }
FaceSet { numVertices [ 4 ] }
# offset polygon-as-lines to be in front of above polygon:
PolygonOffset {
styles LINES
factor -2.0
units 1.0
}
# render lines:
Coordinate3 { point [ -1 -1 0, 1 -1 0, 1 1 0, -1 1 0 ] }
BaseColor { rgb 1 1 0 }
Switch {
# change this to '0' to see how glPolygonOffset() does *not* work
# with "true" lines
whichChild 1
DEF child0 Group {
# can *not* be offset
IndexedLineSet { coordIndex [ 0, 1, 2, 3, 0, 2, -1, 1, 3 -1 ]
}
}
DEF child1 Group {
# will be offset
DrawStyle { style LINES }
FaceSet { numVertices [ 4 ] }
}
}
}
SoPolygonOffset::LINES
@ LINES
Definition SoPolygonOffset.h:53

Field default value is SoPolygonOffset::FILLED.

## on

SoSFBool SoPolygonOffset::on

Whether the offset is on or off. Default is for SoPolygonOffset::on to be `TRUE`.

The documentation for this class was generated from the following files:

- SoPolygonOffset.h
- SoPolygonOffset.cpp